#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <getopt.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <malloc.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/mman.h>
#include <sys/ioctl.h>
#include <asm/types.h>
#include <linux/videodev2.h>
#include <video/vencoder.h>
#include <video/memoryAdapter.h>
#include "camera.h"
#include "H264_encoder.h"
//ʼ
struct H264_encoder* H264_encoder_init(struct camera* camera)
{
		int value = 0;
		struct H264_encoder* H264_encoder = NULL;
		H264_encoder = calloc(1,sizeof(struct H264_encoder));
		int i = 0;
		//* h264 param
		H264_encoder->h264Param.bEntropyCodingCABAC = 1;
		H264_encoder->h264Param.nBitrate = 6 * 1024 * 1024;//
		H264_encoder->h264Param.nFramerate = 30;//֡
		H264_encoder->h264Param.nCodingMode = VENC_FRAME_CODING;//ģʽ
		H264_encoder->h264Param.nMaxKeyInterval = 30;
		H264_encoder->h264Param.sProfileLevel.nProfile = VENC_H264ProfileMain;
		H264_encoder->h264Param.sProfileLevel.nLevel = VENC_H264Level31;
		H264_encoder->h264Param.sQPRange.nMinqp = 10;//С
		H264_encoder->h264Param.sQPRange.nMaxqp = 40;//
		
		memset(&H264_encoder->baseConfig, 0, sizeof(VencBaseConfig));//ջ
		
		if (H264_encoder->baseConfig.memops == NULL)
		{
				H264_encoder->baseConfig.memops = MemAdapterGetOpsS();//ûõڴ
				if (H264_encoder->baseConfig.memops == NULL)
				{
						DEBUG("MemAdapterGetOpsS failed\n");
						return NULL;
				}
				CdcMemOpen(H264_encoder->baseConfig.memops);
		}
		
		H264_encoder->baseConfig.nInputWidth = camera->v4l2_device->resolution.Width;//
		H264_encoder->baseConfig.nInputHeight =camera->v4l2_device->resolution.Height;//
		H264_encoder->baseConfig.nStride = camera->v4l2_device->resolution.Width;//ɸ
		H264_encoder->baseConfig.nDstWidth = camera->v4l2_device->resolution.Width;//DST
		H264_encoder->baseConfig.nDstHeight = camera->v4l2_device->resolution.Height;//DST߶
		//H264_encoder->baseConfig.eInputFormat = VENC_PIXEL_ARGB;//ģʽ,Ϊrgb565
		H264_encoder->baseConfig.eInputFormat = VENC_PIXEL_UYVY422;
		if (H264_encoder->VideoEnc == NULL)//ʼ
		{
				printf("get SPS PPS\n");
				H264_encoder->VideoEnc = VideoEncCreate((VENC_CODEC_TYPE)VENC_CODEC_H264);
				VideoEncSetParameter(H264_encoder->VideoEnc, VENC_IndexParamH264Param, &H264_encoder->h264Param);//д
				value = 0;
				VideoEncSetParameter(H264_encoder->VideoEnc, VENC_IndexParamIfilter, &value);
				value = 0; //degree
				VideoEncSetParameter(H264_encoder->VideoEnc, VENC_IndexParamRotation, &value);
				value = 0;
				VideoEncSetParameter(H264_encoder->VideoEnc, VENC_IndexParamSetPSkip, &value);
				VideoEncInit(H264_encoder->VideoEnc, &H264_encoder->baseConfig);//ʼ
		}
		//ȡͷ
		VideoEncGetParameter(H264_encoder->VideoEnc, VENC_IndexParamH264SPSPPS, &H264_encoder->sps_pps_data);
		//뻺С
		H264_encoder->bufferParam.nSizeY = H264_encoder->baseConfig.nInputWidth * H264_encoder->baseConfig.nInputHeight*2;
		H264_encoder->bufferParam.nSizeC = H264_encoder->baseConfig.nInputWidth * H264_encoder->baseConfig.nInputHeight;//ɸ
		H264_encoder->bufferParam.nBufferNum = 4;
		AllocInputBuffer(H264_encoder->VideoEnc, &H264_encoder->bufferParam);//仺
		H264_encoder->inputbuf_addr = (struct inputbuf_addr*)malloc(sizeof(struct inputbuf_addr)* GET_CAM_MEMBER(camera,buffer_num));
		for(i = 0; i < GET_CAM_MEMBER(camera,buffer_num);i++)
		{
				H264_encoder->inputbuf_addr[i].addrVirY = GET_CAM_MEMBER(camera,image_buf_info)[i].start_addr;
				H264_encoder->inputbuf_addr[i].addrVirC = H264_encoder->inputbuf_addr[i].addrVirY+ALIGN_16B(GET_CAM_MEMBER(camera,resolution).Width) *
																						 													       ALIGN_16B(GET_CAM_MEMBER(camera,resolution).Height);
		}
		return H264_encoder;
		
	
}
int H264_write_head(struct H264_encoder* H264_encoder,FILE* fpH264)//дͷ
{
		fwrite(H264_encoder->sps_pps_data.pBuffer, 1, H264_encoder->sps_pps_data.nLength, fpH264);
}
//˼Ϊʹĸĸͨͼ񣬱֮дǸļȥ,һ֡
int H264_encode_handle(struct H264_encoder* H264_encoder,FILE* fpH264,int channel_num)
{
		int i = channel_num;
		/*û*/
		GetOneAllocInputBuffer(H264_encoder->VideoEnc, &H264_encoder->inputBuffer);//ȡ뻺Ϣ
		/*뻺Ϣ*/
		memcpy(H264_encoder->inputBuffer.pAddrVirY, H264_encoder->inputbuf_addr[i].addrVirY, H264_encoder->baseConfig.nInputWidth * H264_encoder-> baseConfig.nInputHeight*2);//
		memcpy(H264_encoder->inputBuffer.pAddrVirC, H264_encoder->inputbuf_addr[i].addrVirC, H264_encoder->baseConfig.nInputWidth * H264_encoder->baseConfig.nInputHeight);//AddrVirCΪI֡
		H264_encoder->inputBuffer.bEnableCorp = 0;//δ֪пС
		H264_encoder->inputBuffer.sCropInfo.nLeft = 240;//δ֪
		H264_encoder->inputBuffer.sCropInfo.nTop = 240;//δ֪ɸ
		H264_encoder->inputBuffer.sCropInfo.nWidth = 240;//δ֪
		H264_encoder->inputBuffer.sCropInfo.nHeight = 240;//δ֪
		FlushCacheAllocInputBuffer(H264_encoder->VideoEnc, &H264_encoder->inputBuffer);//ϴ뻺
		AddOneInputBuffer(H264_encoder->VideoEnc, &H264_encoder->inputBuffer);//뻺
		if (VENC_RESULT_OK != VideoEncodeOneFrame(H264_encoder->VideoEnc))//ͼݽб
		{
				printf("VideoEncodeOneFrame failed.\n");
				return -1;
		}
		AlreadyUsedInputBuffer(H264_encoder->VideoEnc, &H264_encoder->inputBuffer);//жǷѾʹ뻺
		ReturnOneAllocInputBuffer(H264_encoder->VideoEnc, &H264_encoder->inputBuffer);//һõ뻺

		GetOneBitstreamFrame(H264_encoder->VideoEnc, &H264_encoder->outputBuffer);//ȡõ
		
		if (H264_encoder->outputBuffer.nSize0 > 0)//С0˵Ѿȡ
		{
				printf("write pData0\n");
				fwrite(H264_encoder->outputBuffer.pData0, 1, H264_encoder->outputBuffer.nSize0, fpH264);//дļ
		}
		if (H264_encoder->outputBuffer.nSize1 > 0)
		{
				printf("write pData1\n");
				fwrite(H264_encoder->outputBuffer.pData1, 1, H264_encoder->outputBuffer.nSize1, fpH264);
		}
		FreeOneBitStreamFrame(H264_encoder->VideoEnc, &H264_encoder->outputBuffer);//ͷͼ
		return 1;
}
//رձ
int close_H264_encoder(struct H264_encoder* H264_encoder)
{
				FreeOneBitStreamFrame(H264_encoder->VideoEnc, &H264_encoder->outputBuffer);//ͷ
				if (H264_encoder->baseConfig.memops != NULL)//ղ
				{
						CdcMemClose(H264_encoder->baseConfig.memops);
						H264_encoder->baseConfig.memops = NULL;
				}
				VideoEncDestroy(H264_encoder->VideoEnc);//ٱ
				H264_encoder->VideoEnc = NULL;
				return 0;
}
