#include <sys/select.h>
#include <stdlib.h>
#include <string.h>
#include "selector.h"
#include "list.h"
#include "v4l2_debug.h"

//ʼѡ
struct selector* create_init_selector(int data_num)
{
		struct selector* selector  = NULL;
		selector = calloc(1,sizeof(struct selector));
		set_selector_timeout(selector,1,500);//ʼʱʱ
		FD_ZERO(&selector->rdfd_set);//նio
		FD_ZERO(&selector->wrfd_set);//дio
		selector->return_val = 0;//շֵ
		selector->rdio_list = list_new();//ļio
		selector->wrio_list = list_new();//дļio
		selector->maxfd = 0;
		selector->fd_data_num = data_num;
		selector->data = calloc(1,sizeof(struct fd_data)*data_num);//ݼ
		return selector;
}
//ȴѡɷ
int selector_wait(struct selector* selector,int IO_flag)
{
		struct fd_data* pri_data = NULL;
		int io_num = 0;
		selector->return_val = select((selector->maxfd)+1,&selector->rdfd_set,&selector->wrfd_set,NULL,&selector->select_time);//ȴio
		switch(selector->return_val)
		{
				case -1:
						DEBUG("selector wait failed!\n");
						return selector->return_val;
				case 0:
						DEBUG("selector wait timeout!\n");
						return selector->return_val;
				default:
				{
						if(IO_flag & RDIO)//жûio־
						{
								selector->rdio_iterator = list_iterator_new(selector->rdio_list, LIST_HEAD);//
								while((selector->iterato_node = list_iterator_next(selector->rdio_iterator)))//ڵ
								{
										if(FD_ISSET(((struct fd_data*)selector->iterato_node->val)->fd,&selector->rdfd_set))//жϽڵfdǷΪ첽iofd
										{
												memcpy(&selector->data[io_num],selector->iterato_node->val,sizeof(struct fd_data)); //ֵڵݵݼ
												io_num++;//io1
										}
										selector->iterato_node = list_iterator_next(selector->rdio_iterator);//һڵ
								}
								list_iterator_destroy(selector->rdio_iterator);//ٵ
						}
						if(IO_flag & WRIO)
						{
								selector->wrio_iterator = list_iterator_new(selector->wrio_list, LIST_HEAD);
								while((selector->iterato_node = list_iterator_next(selector->wrio_iterator))) 
								{
										if(FD_ISSET(((struct fd_data*)selector->iterato_node->val)->fd,&selector->wrfd_set))//жϽڵfdǷΪ첽iofd
										{
												memcpy(&selector->data[io_num],selector->iterato_node->val,sizeof(struct fd_data)); 
												io_num++;
										}
										selector->iterato_node = list_iterator_next(selector->wrio_iterator);
								}
								list_iterator_destroy(selector->wrio_iterator);
								
						}
						return io_num;
				}
		}
		
}
//IOѡ
int selector_add_io(struct selector* selector,int fd,void* data,int IO_flag)
{
		struct fd_data* pri_data;
		pri_data = calloc(1,sizeof(struct fd_data));
		if(IO_flag == RDIO)
		{
				pri_data->fd = fd;//˽ݲֵ
				pri_data->data = data;
				FD_SET(fd,&selector->rdfd_set); //  
				list_rpush(selector->rdio_list,list_node_new(pri_data));//˽ݼ
		}
		else if(IO_flag == WRIO)
		{
				pri_data->fd = fd;
				pri_data->data = data;
				FD_SET(fd,&selector->wrfd_set);   
				list_rpush(selector->wrio_list,list_node_new(pri_data));
		}
		selector->maxfd = (selector->maxfd > fd ? selector->maxfd : fd);
		return selector->maxfd;
}
//ѡʱʱ
int set_selector_timeout(struct selector* selector,int sec,int usec)
{
		selector->select_time.tv_sec = sec;
		selector->select_time.tv_usec = usec;
		return 1;
}
//ˢIO
int selector_reset_io(struct selector* selector)
{
		FD_ZERO(&selector->rdfd_set);   //ÿѭҪռϣܼ仯  
		FD_ZERO(&selector->wrfd_set);  
		bzero(selector->data,selector->fd_data_num * sizeof(struct fd_data));
		set_selector_timeout(selector,1,500);//ʼʱʱ
		//뵱ǰеfd
		selector->rdio_iterator = list_iterator_new(selector->rdio_list, LIST_HEAD);
		while((selector->iterato_node = list_iterator_next(selector->rdio_iterator))) //fd
		{
				FD_SET(((struct fd_data*)selector->iterato_node->val)->fd,&selector->rdfd_set);
		}
		list_iterator_destroy(selector->rdio_iterator);
		
		selector->wrio_iterator = list_iterator_new(selector->wrio_list, LIST_HEAD);
		while((selector->iterato_node = list_iterator_next(selector->wrio_iterator))) //дfd
		{
				FD_SET(((struct fd_data*)selector->iterato_node->val)->fd,&selector->wrfd_set);
		}
		return 1;
}


